#<profile4xi profile = "11"/>
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_benchmark_mp_xi4.py">
#<verify4xi verification = "10" target = "process4xi.py"/>
#<contextualize4xi context = "queue4xi.py; pipe4xi.py; lock4xi.py;rlock4xi.py; manager4xi.py; pool4xi.py; value4xi.py; arrayfunction4xi.py; basemanager4xi.py; baseproxy4xi.py; condition4xi.py"/>
#<use4xi usage = "
# 
# BEFORE running check in test_benchmark_mp_xi4.py:
#  1) if focus2original is True <-- tests original multiprocessing
#  2) if focus2hybrid is True <-- tests hyprid multiprocessing2xi
#  3) if focus2dragon is True: <-- tests dragon multiprocessing4xi
#  nb: you may want to run all three to see benchmark (although comparison not always valid)
#      or just 3 to test the latest version
#
#  4) check test4 function options to run different tests:
#     if queue2test is True: <-- runs queue tests
#     if queue2test1 is True: <-- threading.Thread, queue.Queue(),threading.Condition())
#     if queue2test2 is True: <-- testing  Queue speed with multiprocessing
#     if queue2test3 is True: <-- testing hyprid Queue2Xi speed with multiprocessing4xi
#     if queue2test4 is True: <-- testing dragon Queue4Xi speed with multiprocessing4xi
# 
#     if pipe2test is True: <-- runs pipe tests
#     if pipe2test2 is True: <-- testing multiprocessing.Pipe speed
#     if pipe2test3 is True: <-- testing hyprid Pipe2Xi speed 
#     if pipe2test4 is True: <-- testing dragon Pipe4Xi speed 
#
#  5) check test_queuespeed4xi
#     
#  6) tune test_pipespeed4xi 
#     iterations = 33 <-- adjust!
#
# RUN
#     > call t  test_benchmark_mp_xi4 > ..\txt\test_benchmark_mp_xi4.txt
#
# AFTER
#   see STATISTICS in test_benchmark_mp_xi4.txt
# 
# Example of Queue4Xi statistics:
#    GOT FROM QUEUE RESULT:  STOP
#    FINISHED GOT FROM QUEUE, LAST RESULT:  STOP
#    512 objects passed through the queue in  1.4626252214856024 seconds
#    average number/sec: 350.05549779864776
# 
# Example of Pipe4Xi statistics:
# ==================================================
#    ITERATIONS:  33
#    CHANNEL  1
#    COUNT2SENT:  2
#    COUNT2RECEIVED:  35
#    COUNT2FAILED:  0
#    ELAPSED2COMMUNICATE;  0.14563260370118547
#    COUNT2COMMUNICATE:  153
#    COUNT2RECEIVED  35  = ITERATIONS + 2  35  <=> ALL DATA RECEIVED
#    ELAPSED2COMMUNICATE  0.14563260370118547  < MAX2DELTA:  1.33  ENOUGH TIME ALLOCATED
#    COUNT2COMMUNICATE  153  >= MAX2COMMUNICATE:  132  ITERATIONS USED
#    RESULT  <data4xi>STOP</data4xi>  LAST RECEIVED MESSAGE
#    SEND CHANNEL  1 : <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003B23E80>
#    RECEIVE CHANNEL  1 : <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003A4D550>
#    33 OBJECTS PASSED THROUGH CONNECTION IN  0.14563260370118547  SECONDS
#    AVERAGE NUMBER/SEC: 226.59761043420372
# ==================================================
# VIEW with browser:
#    sense-test-benchmark4xi.xml
#    reason-test-benchmark4xi.xml
#    ace-test-benchmark4xi.xml
#"
#/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'test4',  
            'test2',
            'test1', 
            'test_conditionspeed',
            'conditionspeed_func',  
            'test_lockspeed',
            'test_seqspeed', 
            'test_pipespeed',
            'test_pipespeed2xi',
            'test_pipespeed4xi',  
            'pipe_func',
            'test_queuespeed',
            'test_queuespeed2xi',
            'test_queuespeed4xi',                                                                          
            'queuespeed_func',
            'queuespeed_func4xi',
                             
            'print_trace4xi',
            'set_trace4xi',            
            'deny_trace4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:                 # most-common ones
    import time
    import random
    import operator         
except:
    pass
try:                 # rare ones
    from ctypes import Structure, c_double
    import gc
    import queue # <--- NOT Queue as in the original example
     
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>


# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    import multiprocessing

    from multiprocessing import Process
    from multiprocessing import Queue
    from multiprocessing import Pipe
    from multiprocessing import Lock
    from multiprocessing import Manager
    from multiprocessing import Pool
    from multiprocessing import current_process
    from multiprocessing import freeze_support
    
    
    from multiprocessing.sharedctypes import Value, Array
    from multiprocessing.managers import BaseManager, BaseProxy
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from arrayfunction4xi import ArrayFunction4Xi
from arrayfunction2xi import ArrayFunction2Xi
 
from basemanager4xi import BaseManager4Xi
from baseproxy4xi import BaseProxy4Xi
from basemanager2xi import BaseManager2Xi
from baseproxy2xi import BaseProxy2Xi

from condition4xi import Condition4Xi  
from condition2xi import Condition2Xi  

from dummyprocess4xi import DummyProcess4Xi

from process2xi import Process2Xi

from pipe2xi import Pipe2Xi

from lock2xi import Lock2Xi
from lock4xi import Lock4Xi

from manager4xi import Manager4Xi
from manager2xi import Manager2Xi 

from pipe4xi import Pipe4Xi
from pool4xi import Pool4Xi
from pool2xi import Pool2Xi
from process4xi import Process4Xi

from queue4xi  import Queue4Xi
from queue2xi  import Queue2Xi

from rlock4xi import RLock4Xi
from rlock2xi import RLock2Xi

from value4xi import Value4Xi
from value2xi import Value2Xi


from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi 
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi
      
from print4xi import Print4Xi

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
if sys.platform == 'win32':
    _timer = time.clock
else:
    _timer = time.time

delta = 1


#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    __all__ = [ 'cpu_corecount4xi', 'sense_function4xi', 'reason_function4xi', 'ace_function4xi'] 
    
    KB4Tailoring = {
                # 'Manager4Xi': 'ACK4TRACE',                           
                # 'SyncManager4Xi': 'NACK4TRACE',                           
                'Process4Xi': 'NACK4TRACE',                               
                # 'Client4Xi': 'NACK4TRACE',                                
                # '_MainProcess4Xi': 'NACK4TRACE',                          
                # 'get_preparation_data4xi': 'NACK4TRACE',                  
                # 'Listener4Xi': 'NACK4TRACE',                              
                # 'Lock4Xi':'NACK4TRACE',                                   
                # 'MainProcess4Xi': 'NACK4TRACE',                       
                'Pipe4Xi': 'NACK4TRACE',
                'PipeConnection4Xi': 'NACK4TRACE',                                
                # 'dump': 'NACK4TRACE',                                      
                # 'duplicate': 'NACK4TRACE',                            
                'Popen4Xi': 'NACK4TRACE',                              
                # 'is_forking': 'NACK4TRACE',                          
                # 'freeze_support': 'NACK4TRACE',                  
                # 'get_command_line': 'NACK4TRACE',              
                # 'main': 'NACK4TRACE',                                      
                # 'reduce_connection': 'NACK4TRACE',            
                'Queue4Xi': 'NACK4TRACE',                              
                # 'SemLock4Xi': 'NACK4TRACE'                            
                # 'Server4Xi': 'NACK4TRACE',
                # 'PipeListener4Xi': 'NACK4TRACE',
                # 'Listener4Xi': 'NACK4TRACE'
                '_ConnectionBase4Xi': 'NACK4TRACE'
                }       
                      
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>       
             

 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   printing trace
#">                    
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-test-benchmark4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Benchmark in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Benchmark in Multiprocessing.</rdfs:comment>\n'}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-test-benchmark4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Benchmark in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Benchmark in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n'}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-test-benchmark4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Benchmark in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Benchmark in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n'}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
              
#[*]
# -------------------------------------------------------------------------------------------------
#<function4xi function = "queuespeed_func" usage = "
#   test_queuespeed
#"> 
# -------------------------------------------------------------------------------------------------
def queuespeed_func(q, c, iterations):
    a = '0' * 256
    c.acquire()
    c.notify()
    c.release()

    for i in range(iterations):
        q.put(a)

    q.put('STOP')
#</function4xi>

#[4]
# -------------------------------------------------------------------------------------------------
#<function4xi function = "queuespeed_func4xi" usage = "
#   p2xi = Process4Xi(target=queuespeed_func4xi, args=(q2xi,iterations))
#"> 
# -------------------------------------------------------------------------------------------------
def queuespeed_func4xi(q2xi, iterations):
    print("queuespeed_func4xi: passed q: ", q2xi)
    # <queue4xi.Queue4Xi object at 0x00000000039265F8>
    print("queuespeed_func4xi: passed iterations: ", iterations)
    # 2
    
    a = '0' * 256
    count2put = 0
    count2failed = 0

    for i in range(iterations):
        try:
            q2xi.put(a)
            #1 { Queue4Xi : put ; passed; object-passed-to-put-of-Queue4Xi: 000000000000000000000000000000000000000000 ...
            #  { Queue4Xi : put ; (Step 5/8a) passing; object-passing-to-buffer-append-of-queue2xi-by-put-of-Queue4Xi: 000000000000000000000000000000000000000000000000 ...
            #  { Queue4Xi : put ; (Step 8/8) returning; put-of-Queue4Xi-returning: 05:59:58 02/15/13 Pacific Standard Time}
            #2 { Queue4Xi : put ; passed; object-passed-to-put-of-Queue4Xi: 000000000000000000000000000000000000000000000000 ...
            # 
            count2put = count2put + 1
        except:
            print("queuespeed_func4xi *** failed to put a: ", a)
            count2failed = count2failed + 1
    try:             
        q2xi.put('STOP')
        print("queuespeed_func4xi put STOP to q2xi: ", q2xi)
        # <queue4xi.Queue4Xi object at 0x00000000039265F8>
        count2put = count2put + 1
    except:
        print("queuespeed_func4xi *** failed to put STOP ", time4xi())
        count2failed = count2failed + 1
        
    if (count2put == iterations + 1):
        print("queuespeed_func4xi put all - iterations: ", iterations, " count2put: ", count2put, " count2failed: ", count2failed)
    else:
        print("queuespeed_func4xi *** failed to put all - iterations: ", iterations, " count2put: ", count2put, " count2failed: ", count2failed)     
    
#</function4xi>

    
#[*]    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_queuespeed" usage = "
#   test_queuespeed(multiprocessing.Process, multiprocessing.Queue(),  multiprocessing.Condition())
#"> 
# -------------------------------------------------------------------------------------------------
def test_queuespeed(Process, q, c):
    print ('Process passed to test_queuespeed: ', Process)
    print ('q passed to test_queuespeed:  ', q)
    print ('c passed to test_queuespeed: ', c)
    
    elapsed = 0
    iterations = 1

    while elapsed < delta:
        iterations *= 2

        p = Process(target=queuespeed_func, args=(q, c, iterations))
        c.acquire()
        p.start()
        c.wait()
        c.release()

        result = None
        t = _timer()

        while result != 'STOP':
            result = q.get()

        elapsed = _timer() - t

        p.join()

    print (iterations, 'objects passed through the queue in', elapsed, 'seconds')
    print ('average number/sec:', iterations/elapsed)
#</function4xi>

#[4]   
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_queuespeed4xi" usage = "
#   test_queuespeed4xi()
#"> 
# -------------------------------------------------------------------------------------------------
def test_queuespeed4xi():

    elapsed = 0
    iterations = 1
    
    count2none  = 0
    count2data  = 0
    count2total = 0
    
    q2xi = Queue4Xi()
    print ('(STEP 1/33) OF TEST_QUEUESPEED4XI - CREATED Q2XI: ', q2xi)  
    # <queue4xi.Queue4Xi object at 0x0000000003A165F8> 
    
    ack2dummy = True
    
    while elapsed < delta:
        iterations *= 2
        
        ack2process = False
        try:
            if ack2dummy is False:
                p2xi = Process4Xi(target=queuespeed_func4xi, args=(q2xi, iterations))
                
                print ('(STEP 2A/33) OF TEST_QUEUESPEED4XI - CREATED PROCESS4XI OBJECT P2XI: ', p2xi)
                ack2process = True
            else:
                p2xi = DummyProcess4Xi(target=queuespeed_func4xi, args=(q2xi, iterations))
                print ('(STEP 3/33) TEST_QUEUESPEED4XI - CREATED DUMMYPROCESS4XI OBJECT P2XI: ', p2xi)
                # <DummyProcess4Xi(Thread-2, initial)>
                
                ack2process = True                    
        except:
            print ('(STEP 2Z/33) OF TEST_QUEUESPEED4XI *** FAILED TO CREATE PROCESS ', time4xi())
        
        if ack2process is True:    
            ack2start = False
            try:        
                # condition2xi.acquire()
                p2xi.start()
                print ('(STEP 3A/33) OF TEST_QUEUESPEED4XI - STARTED  PROCESS P2XI: ', p2xi)
                ack2start = True
            except:
                print ('test_queuespeed4xi *** failed to start process ', time4xi())
            
            ack2run = False
            if ack2dummy is False:
                if ack2start is True: 
                    try:       
                        p2xi.run()                 # process must be run in dragonized multiprocessing
                        print ('(STEP 3B/33) OF TEST_QUEUESPEED4XI - RUN PROCESS4XI OBJECT P2XI: ', p2xi)
                        ack2run = True
                        # condition2xi.wait()
                        # condition2xi.release()
                    except:
                        print ('(STEP 3Z/33) OF TEST_QUEUESPEED4XI *** FAILED TO RUN PROCESS ', time4xi())
            else:
                ack2run = True  # fake run with dummy process
                
            print ('(STEP 4A/33) OF TEST_QUEUESPEED4XI - PREPARED TO GET FROM QUEUE : ', q2xi) 
            # <queue4xi.Queue4Xi object at 0x0000000003A165F8>
                       
            if ((ack2process is True) and (ack2start is True) and (ack2run is True)):
                result = None
                t = _timer()
        
                while result != 'STOP':
                    result = q2xi.get()
                    print ('(STEP 4B/33) OF TEST_QUEUESPEED4XI - GOT FROM QUEUE RESULT: ', result) 
                    # 00000000000000000000000000000000000000000000000000000
                    # 00000000000000000000000000000000000000000000000000000
                    # 
                    count2total = count2total + 1
                    if result is None:
                        count2none = count2none + 1
                        print ('(STEP 4Z1/33) OF TEST_QUEUESPEED4XI *** ERROR GOT FROM QUEUE RESULT: ', result) 
                        break
                    else:
                        count2data = count2data + 1
                print ('(STEP 4C/33) OF TEST_QUEUESPEED4XI - FINISHED GOT FROM QUEUE, LAST RESULT: ', result)
                # STOP         
            else:
                print ('test_queuespeed4xi *** error - passed get - ack2process: ', ack2process, ' ack2start: ', ack2start, ' ack2run: ', ack2run)             
        else:
            pass
                                    
        elapsed = _timer() - t

        # p2xi.join()

    print ('(STEP 5A/33) OF TEST_QUEUESPEED4XI - TRYING TO PRINT QUEUE STATISTICS ', time4xi()) 
    
    
    try:      
        print (iterations, 'objects passed through the queue in ', elapsed, 'seconds')
        # 512 objects passed through the queue in  1.4896834589640913 seconds
        print ('average number/sec:', iterations/elapsed)
        # 343.69717735608
        if count2data == count2total:
            print ('(STEP 5B/33) OF TEST_QUEUESPEED4XI - COUNT2DATA: ', count2data, ' == COUNT2TOTAL: ', count2total)
            # 1031  == COUNT2TOTAL:  1031
        else:
            print ('(STEP 5C/33) TEST_QUEUESPEED4XI *** ERROR - COUNT2DATA: ', count2data, ' COUNT2NONEN: ', count2none, ' COUNT2TOTAL: ', count2total)
    except:
        print ('(STEP 5Z/33) OF TEST_QUEUESPEED4XI *** FAILED TO PRINT QUEUE STATISTICS ', time4xi())
             
#</function4xi>



#[*]
# -------------------------------------------------------------------------------------------------
#<function4xi function = "pipe_func" usage = "
#   test_pipespeed
#"> 
# -------------------------------------------------------------------------------------------------
def pipe_func(c, cond, iterations):
    a = '0' * 256
    cond.acquire()
    cond.notify()
    cond.release()

    for i in range(iterations):
        c.send(a)

    c.send('STOP')
#</function4xi>


#[4]
# -------------------------------------------------------------------------------------------------
#<function4xi function = "pipe_func4xi" usage = "
#   test Pipe4Xi speed
#"> 
# -------------------------------------------------------------------------------------------------
def pipe_func4xi(channel2send, channel2receive, iterations):
    
    print("(STEP 1A/33) OF PIPE_FUNC4XI - PASSED CHANNEL2SEND: ", channel2send)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000039B5438> 

    print("(STEP 1B/33) OF PIPE_FUNC4XI - PASSED CHANNEL2RECEIVE: ", channel2receive)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000039B5470>
    print("(STEP 1C/33) OF PIPE_FUNC4XI - PASSED ITERATIONS: ", iterations)
    # 2
    
    a = '0' * 256
    count2sent     = 0
    count2failed   = 0
    count2received = 0

    try:
        # --------------------------------------------------------------------------------
        # RECEIVE COPY - CALLER IS COLLECTOR - THIS BEING PROVIDER
        # --------------------------------------------------------------------------------
        message2receive = channel2receive.recv() 
        if message2receive == "<copy4xi>copy</copy4xi>":
            print("(STEP 2A/33) OF PIPE_FUNC4XI -  RECEIVED FROM ", channel2receive, " MESSAGE: ", message2receive)
            # RECEIVED FROM  <pipeconnection4xi.PipeConnection4Xi object at 0x00000000039B5470>  MESSAGE:  <copy4xi>copy</copy4xi> 
            count2received = count2received + 1
            
            try:
                # --------------------------------------------------------------------------------
                # SEND ROGER - CALLER IS COLLECTOR - THIS BEING PROVIDER
                # --------------------------------------------------------------------------------
                message2send ="<roger4xi>roger</roger4xi>"
                channel2send.send(message2send)
                print("(STEP 2B/33) OF PIPE_FUNC4XI SENT: ", message2send)
                # <roger4xi>roger</roger4xi>
                count2sent = count2sent + 1
        
            except:
                print("(STEP 2Z1/33) OF PIPE_FUNC4XI SENT *** FAILED TO SEND  ROGER ", time4xi())
                count2failed = count2failed + 1 
        else:
            print("(STEP 2Z2/33) OF PIPE_FUNC4XI *** FROM ", channel2receive, " WRONG MESSAGE: ", message2receive)
            count2failed = count2failed + 1 
            # <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003948438>  WRONG MESSAGE:  <ack4xi>ack2data</ack4xi>
    except:
        print("(STEP 2Z3/33) OF PIPE_FUNC4XI SENT *** FAILED TO SEND  ROGER ", time4xi())
        count2failed = count2failed + 1
                        

    # -----------------------------------------------------------------------------------------
    # DATA
    # -----------------------------------------------------------------------------------------  
    for i in range(iterations):
        try:
            ack2send = False
            # --------------------------------------------------------------------------------
            # SEND ALL DATA
            # --------------------------------------------------------------------------------
            message2send ="<data4xi>" + str(i) + "-benchmark</data4xi>"
            channel2send.send(message2send) 
            print("(STEP 3A/33) OF PIPE_FUNC4XI SENT: ", message2send)
            # <data4xi>0-benchmark</data4xi>
            # <data4xi>1-benchmark</data4xi>
            #  
            count2sent = count2sent + 1
            ack2send = True
        except:
            print("(STEP 3Z1/33) OF PIPE_FUNC4XI SENT *** FAILED TO SEND  ROGER ", time4xi())
            count2failed = count2failed + 1    

           
    # -----------------------------------------------------------------------------------------
    # STOP
    # -----------------------------------------------------------------------------------------        
    print("(STEP 3B/33) OF PIPE_FUNC4XI - TRYING TO SEND STOP  ", time4xi()) 
    # 04:08:49 02/16/13 Pacific Standard Time           
    try:
        message2send ="<data4xi>STOP</data4xi>"            
        channel2send.send(message2send)
        # 
           
        print("(STEP 3C/33) OF PIPE_FUNC4XI - SENT STOP  ", message2send) 
        # <data4xi>STOP</data4xi>
        
        count2sent = count2sent + 1
    except:
        print("(STEP 3Z2/33) OF PIPE_FUNC4XI SENT *** FAILED TO SEND STOP  ", time4xi())
        count2failed = count2failed + 1
     
            
    # -----------------------------------------------------------------------------------------
    # STATISTICS AND RETURN
    # -----------------------------------------------------------------------------------------              
    print("(STEP 4A/33) OF PIPE_FUNC4XI - TRYING STATISTICS ", time4xi())
    # 04:08:49 02/16/13 Pacific Standard Time   
    try:         
        print("(STEP 4B/33) OF PIPE_FUNC4XI SENT - ITERATIONS: ", iterations, " COUNT2SENT: ", count2sent, " COUNT2RECEIVED: ", count2received, " COUNT2FAILED: ", count2failed)
        # ITERATIONS:  2  COUNT2SENT:  4  COUNT2RECEIVED:  1  COUNT2FAILED:  0   
    except:
        print("(STEP 4Z/33) OF PIPE_FUNC4XI *** FAILED IN STATISTICS ", time4xi()) 

        
    print("(STEP 33/33) OF PIPE_FUNC4XI - RETURNING ", time4xi())
    # 
            
#</function4xi>


    
#[1]    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_pipespeed" usage = "
#   testing pipe speed with Process
#"> 
# -------------------------------------------------------------------------------------------------
def test_pipespeed():
    c, d = multiprocessing.Pipe()
    cond = multiprocessing.Condition()
    elapsed = 0
    iterations = 1

    while elapsed < delta:
        iterations *= 2

        p = multiprocessing.Process(target=pipe_func,
                                    args=(d, cond, iterations))
        cond.acquire()
        p.start()
        cond.wait()
        cond.release()

        result = None
        t = _timer()

        while result != 'STOP':
            result = c.recv()

        elapsed = _timer() - t
        p.join()

    print (iterations, 'objects passed through connection in',elapsed,'seconds')
    print ('average number/sec:', iterations/elapsed)
#</function4xi>

#[2]    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_pipespeed2xi" usage = "
#   testing receiving speed of pipes with Process
#"> 
# -------------------------------------------------------------------------------------------------
def test_pipespeed2xi():
    c, d = Pipe2Xi()
    cond = Condition2Xi()
    elapsed = 0
    iterations = 1

    while elapsed < delta:
        iterations *= 2

        p = Process2Xi(target=pipe_func, args=(d, cond, iterations))
        cond.acquire()
        p.start()
        cond.wait()
        cond.release()

        result = None
        t = _timer()

        while result != 'STOP':
            result = c.recv()

        elapsed = _timer() - t
        p.join()

    print (iterations, 'objects passed through connection in',elapsed,'seconds')
    print ('average number/sec:', iterations/elapsed)
    
#</function4xi>

#[4]    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_pipespeed4xi" usage = "
#   testing pipe speed with Process4Xi
#"> 
# -------------------------------------------------------------------------------------------------
def test_pipespeed4xi():
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print ('(STEP 0A/33) OF TEST_PIPESPEED4XI - TEST_PIPESPEED4XI STARTED ', time4xi())   
    #  04:08:49 02/16/13 Pacific Standard Time
    
    kb2deliver = {}             # channels for delivery
    kb2receive = {}             #              reception
    key2wave = 0
                
    elapsed = 0                
    iterations = 33             # JATKA OK2; OK4; OK8; OK20; OK33; OK40; OK80; OK800 <-- vary this!
    max2iterations = 2
    
    count2sent = 0
    count2received = 0
    count2failed = 0
    
    ack2dummy = True            # only option: use DummyProcess4Xi, which you only start
                                #                - with Process4Xi, you have to both start and run
                                
                                
    ack2duplex = True           # only option: you both send and receive!                 
                                
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print ('(STEP 0B/33) OF TEST_PIPESPEED4XI - ELAPSED: ', elapsed, ' DELTA: ', delta, ' MAX2ITERATIONS: ', max2iterations, ' ', time4xi())
    # ELAPSED:  0  DELTA:  1  MAX2ITERATIONS:  2   04:08:49 02/16/13 Pacific Standard Time
    print ('(STEP 0C/33) OF TEST_PIPESPEED4XI - STARTING TRIALS TO ITERATE ', ' ACK2DUPLEX: ', ack2duplex, time4xi())
    # ACK2DUPLEX:  True 04:08:49 02/16/13 Pacific Standard Time
    
    # -----------------------------------------------------------------------------------------
    #
    # -----------------------------------------------------------------------------------------    
      
    # while ((elapsed < delta) and (iterations < max2iterations)):
    #     iterations = iterations + 1
    print ('(STEP 1A/33) OF TEST_PIPESPEED4XI - STARTING ITERATION ', iterations)   
    # STARTING ITERATION  2
        
    # -------------------------------------------------------------------------------------
    # PIPE
    # -------------------------------------------------------------------------------------
    key2wave = key2wave + 1
    print ('(STEP 1B/33) OF TEST_PIPESPEED4XI - STARTING WAVE ', key2wave)   
    # 1
        
    if ack2duplex is False:
        kb2deliver[key2wave], kb2receive[key2wave] = Pipe4Xi(duplex=False)
        print ('(STEP 1C/33) OF TEST_PIPESPEED4XI - NON-DUPLEX DELIVERY CHANNEL ', key2wave, ' TO SEND: ', kb2deliver[key2wave])   
        # 
        print ('(STEP 1D/33) OF TEST_PIPESPEED4XI - NON-DUPLEX RECEPTION CHANNEL ', key2wave, ' TO RECEIVE: ', kb2receive[key2wave])
        # 
    else:
        kb2deliver[key2wave], kb2receive[key2wave] = Pipe4Xi(duplex=True)        
          
        print ('(STEP 1E/33) OF TEST_PIPESPEED4XI - DUPLEX DELIVERY CHANNEL ', key2wave, ' TO SEND: ', kb2deliver[key2wave])   
        # DUPLEX DELIVERY CHANNEL  1  TO SEND:  <pipeconnection4xi.PipeConnection4Xi object at 0x00000000039B5438>
            
        print ('(STEP 1F/33) OF TEST_PIPESPEED4XI - DUPLEX RECEPTION CHANNEL ', key2wave, ' TO RECEIVE: ', kb2receive[key2wave])
        # DUPLEX RECEPTION CHANNEL  1  TO RECEIVE:  <pipeconnection4xi.PipeConnection4Xi object at 0x00000000039B5470>
    

      
    # -------------------------------------------------------------------------------------
    # PROCESS WITH TARGET FUNCTION
    # -------------------------------------------------------------------------------------              
    print ('(STEP 2A/33) OF TEST_PIPESPEED4XI - CREATING PROCESS ', time4xi())
    # 04:08:49 02/16/13 Pacific Standard Time
    ack2process = False
    try:
        if ack2dummy is False:
            p2xi = Process4Xi(target=pipe_func4xi, args=(kb2deliver[key2wave], kb2receive[key2wave], iterations))
            print ('(STEP 2A/33) OF TEST_PIPESPEED4XI - CREATED PROCESS4XI OBJECT P2XI: ', p2xi)
            ack2process = True
        else:
            p2xi = DummyProcess4Xi(target=pipe_func4xi, args=(kb2deliver[key2wave], kb2receive[key2wave], iterations))
            print ('(STEP 2B/33) OF TEST_PIPESPEED4XI - CREATED DUMMYPROCESS4XI OBJECT P2XI: ', p2xi)
            # <DummyProcess4Xi(Thread-1, initial)>
                
            ack2process = True
    except:
        print ('(STEP 2Z/33) OF TEST_PIPESPEED4XI *** FAILED TO CREATE PROCESS ', time4xi())
            
     
                   
    # -------------------------------------------------------------------------------------
    # START
    # -------------------------------------------------------------------------------------            
    print ('(STEP 3A/33) OF TEST_PIPESPEED4XI - STARTING PROCESS  ', time4xi())
    # 04:08:49 02/16/13 Pacific Standard Time
    ack2start = False
    if ack2process is True:
        try: 
                    
            p2xi.start()
            print ('(STEP 3B/33) OF TEST_PIPESPEED4XI - STARTED P2XI: ', p2xi)
            # <DummyProcess4Xi(Thread-1, started 1232)>
            ack2start = True
        except:
            print ('(STEP 3Z/33) OF TEST_PIPESPEED4XI *** FAILED TO START PROCESS  ', time4xi())
            
             
    # -------------------------------------------------------------------------------------
    # RUN IF REQUIRED
    # -------------------------------------------------------------------------------------
    if ack2dummy is False:                
        ack2run = False
        if ((ack2process is True) and (ack2start is True)):
            print ('(STEP 4A/33) OF TEST_PIPESPEED4XI - RUNNING PROCESS  ', time4xi())
            try:        
                p2xi.run()              # run command mandatory
                print ('(STEP 4B/33) OF TEST_PIPESPEED4XI - RUN P2XI: ', p2xi)
                ack2run = True
            except:
                print ('(STEP 4Z1/33) OF TEST_PIPESPEED4XI *** FAILED TO RUN PROCESS  ', time4xi())
                # break
    else:
        ack2run = True                  # fake run command to dummy process
            
 
    try:
        # --------------------------------------------------------------------------------
        # SEND COPY AS COLLECTOR
        # --------------------------------------------------------------------------------
        message2send ="<copy4xi>copy</copy4xi>"
        kb2deliver[key2wave].send(message2send)
        print("(STEP 4C/33) OF TEST_PIPESPEED4XI - SENT COPY: ", message2send)
        # <copy4xi>copy</copy4xi>
        
        count2sent = count2sent + 1
        
    except:
        print("(STEP 4Z2/33) OF OF TEST_PIPESPEED4XI *** FAILED TO SEND COPY ", time4xi())
        count2failed = count2failed + 1
                    
 
    if ((ack2process is True) and (ack2start is True) and (ack2run is True)):
        elapsed2communicate = 0
        print ('(STEP 5A/33) OF TEST_PIPESPEED4XI - ELAPSED2COMMUNICATE ', elapsed2communicate) 
        # 0
        
        count2communicate = 0
        t = _timer()
        print ('(STEP 5B/33) OF TEST_PIPESPEED4XI - TIME ', t)    
        # 6.378313733306757e-07
            
        # -------------------------------------------------------------------------------------
        # COMMUNICATE WITH TARGET - HANDLE THE CASE TARGET IS EITHER DEAD OR DOING NOTHING
        # -------------------------------------------------------------------------------------
        print ('(STEP 5C1/33) OF TEST_PIPESPEED4XI - STARTING TO COMMUNICATE WITH TARGET ', time4xi())
        # 04:08:49 02/16/13 Pacific Standard Time
        
        max2communicate = iterations * 4     # JATKA tune this
        max2delta = delta + iterations/100   # JATKA tune this 
        print ('(STEP 5C2/33) OF TEST_PIPESPEED4XI - DELTA: ', delta, ' ITERATIONS: ', iterations, ' MAX2DELTA: ', max2delta, ' MAX2COMMUNICATE: ', max2communicate)
        # DELTA:  1  ITERATIONS:  800  MAX2DELTA:  9.0  MAX2COMMUNICATE:  3200
        
            
        while ((elapsed2communicate < max2delta) and (count2communicate < max2communicate)):    
                                
            count2communicate = count2communicate + 1
                
            # -------------------------------------------------------------------------------------
            # RECEIVE AND SEND IF NECESSARY
            # -------------------------------------------------------------------------------------
            print ('(STEP 5D/33) OF TEST_PIPESPEED4XI - CALLING RECEIVE ', kb2receive[key2wave].recv) 
            # <bound method PipeConnection4Xi.recv of <pipeconnection4xi.PipeConnection4Xi object at 0x00000000039B5470>>
            result = 'NACK'
            try:
                result = kb2receive[key2wave].recv()
                                    
                if result is None:
                    print ('(STEP 5E/33) OF TEST_PIPESPEED4XI - RECEIVED NONE FROM CHANNEL ', key2wave, ' RESULT: ', result)
                    #
                                          
                    count2communicate = max2communicate + 13
                    
                if result == "<data4xi>STOP</data4xi>":
                    print ('(STEP 5F1/33) OF TEST_PIPESPEED4XI - RECEIVED FROM CHANNEL ', key2wave, ' STOP: ', result)
                    # <data4xi>STOP</data4xi>
                    
                    # -------------------------------------------------------------------------------------------------
                    # SEND ACK TO STOP AND FINISH LOOP
                    # -------------------------------------------------------------------------------------------------
                    count2received = count2received + 1  
                    
                    message2send = "<ack4xi>ack2stop</ack4xi>"
                    kb2deliver[key2wave].send(message2send) 
                    
                    count2sent = count2sent + 1
                     
                    count2communicate = max2communicate + 21
                else:
                    if result == "<roger4xi>roger</roger4xi>":
                        # -------------------------------------------------------------------------------------------------
                        # RECEIVED ROGER WHICH MEANS CLIENT IS ALIVE - YOU CAN CONTINUE EXPECTING DATA
                        # ------------------------------------------------------------------------------------------------- 
                        count2received = count2received + 1
                        print ('(STEP 5F2/33) OF TEST_PIPESPEED4XI - RECEIVED FROM CHANNEL ', key2wave, ' ROGER: ', result)
                        # RECEIVED FROM CHANNEL  1  ROGER:  <roger4xi>roger</roger4xi> 
                    else:   
                        # -------------------------------------------------------------------------------------------------
                        # RECEIVED DATA - DO NOT SEND ACK BECAUSE PROVIDER SENDS DATA IN BIG CHUNK!
                        # -------------------------------------------------------------------------------------------------
                        count2received = count2received + 1 
                        print ('(STEP 5F3/33) OF TEST_PIPESPEED4XI - RECEIVED FROM CHANNEL ', key2wave, ' DATA : ', result)
                        # <data4xi>0-benchmark</data4xi>
                        # <data4xi>1-benchmark</data4xi>
                    
            except:
                count2communicate = max2communicate + 13
                
            elapsed2communicate = _timer() - t
            print ('(STEP 5G/33) OF TEST_PIPESPEED4XI - ELAPSED2COMMUNICATE ', elapsed2communicate)
            # 0.004670520231213873; 0.00942714769782782
        
        #    
        print ('==================================================')    
        print ('(STEP 5H/33) OF TEST_PIPESPEED4XI - STATISTICS ', time4xi())    
        print ('==================================================')                      
        print ('ITERATIONS: ', iterations)
        print ('CHANNEL ', key2wave)
        print ('COUNT2SENT: ', count2sent)
        print ('COUNT2RECEIVED: ', count2received)
        print ('COUNT2FAILED: ', count2failed)
        print ('ELAPSED2COMMUNICATE; ', elapsed2communicate)
        print ('COUNT2COMMUNICATE: ', count2communicate)
        if count2received == iterations + 2:
            print ('COUNT2RECEIVED ', count2received, ' = ITERATIONS + 2 ', iterations + 2, ' <=> ALL DATA RECEIVED')
        else:
            print ('*** ERROR - COUNT2RECEIVED ', count2received, ' .NE. ITERATIONS + 2 ', iterations + 2, ' <=> SOME DATA LOST ***')     
        
        if elapsed2communicate < max2delta:
            print ('ELAPSED2COMMUNICATE ', elapsed2communicate, ' < MAX2DELTA: ', max2delta, ' ENOUGH TIME ALLOCATED')
        else:
            print ('ELAPSED2COMMUNICATE ', elapsed2communicate, ' >= MAX2DELTA: ', max2delta, ' TIMEOUT IN RECEIVING')
        if count2communicate < max2communicate:
            print ('COUNT2COMMUNICATE ', count2communicate, ' < MAX2COMMUNICATE: ', max2communicate, ' ENOUGH ITERATIONS ALLOCATED')
        else:
            print ('COUNT2COMMUNICATE ', count2communicate, ' >= MAX2COMMUNICATE: ', max2communicate, ' ITERATIONS USED')                    
        if result == 'NACK':
            print ('RESULT ', result, ' LAST PREPARATION TO RECEIVE')
        else:
            print ('RESULT ', result, ' LAST RECEIVED MESSAGE')
              
        
        
        # ==================================================
        # ITERATIONS:  4
        # CHANNEL  1
        # COUNT2SENT:  2
        # COUNT2RECEIVED:  6
        # COUNT2FAILED:  0
        # ELAPSED2COMMUNICATE;  0.028349053219055214
        # COUNT2COMMUNICATE:  54
        # COUNT2RECEIVED  6  = ITERATIONS + 2  6  <=> ALL DATA RECEIVED
        # ELAPSED2COMMUNICATE  0.028349053219055214  < DELTA:  1  ENOUGH TIME ALLOCATED
        # COUNT2COMMUNICATE  54  >= MAX2COMMUNICATE:  33  ITERATIONS USED
        # RESULT  <data4xi>STOP</data4xi>  LAST RECEIVED MESSAGE
        # ==================================================

        # ==================================================
        # ITERATIONS:  8
        # CHANNEL  1
        # COUNT2SENT:  2
        # COUNT2RECEIVED:  10
        # COUNT2FAILED:  0
        # ELAPSED2COMMUNICATE;  0.04465138529001395
        # COUNT2COMMUNICATE:  54
        # COUNT2RECEIVED  10  = ITERATIONS + 2  10  <=> ALL DATA RECEIVED
        # ELAPSED2COMMUNICATE  0.04465138529001395  < DELTA:  1  ENOUGH TIME ALLOCATED
        # COUNT2COMMUNICATE  54  >= MAX2COMMUNICATE:  33  ITERATIONS USED
        # RESULT  <data4xi>STOP</data4xi>  LAST RECEIVED MESSAGE
        # ==================================================

        # ==================================================
        # ITERATIONS:  20
        # CHANNEL  1
        # COUNT2SENT:  2
        # COUNT2RECEIVED:  22
        # COUNT2FAILED:  0
        # ELAPSED2COMMUNICATE;  0.09356667331074348
        # COUNT2COMMUNICATE:  54
        # COUNT2RECEIVED  22  = ITERATIONS + 2  22  <=> ALL DATA RECEIVED
        # ELAPSED2COMMUNICATE  0.09356667331074348  < DELTA:  1  ENOUGH TIME ALLOCATED
        # COUNT2COMMUNICATE  54  >= MAX2COMMUNICATE:  33  ITERATIONS USED
        # RESULT  <data4xi>STOP</data4xi>  LAST RECEIVED MESSAGE
        # ================================================== 

        # ==================================================
        # ITERATIONS:  33
        # CHANNEL  1
        # COUNT2SENT:  2
        # COUNT2RECEIVED:  35
        # COUNT2FAILED:  0
        # ELAPSED2COMMUNICATE;  0.1377937036219672
        # COUNT2COMMUNICATE:  153
        # COUNT2RECEIVED  35  = ITERATIONS + 2  35  <=> ALL DATA RECEIVED
        # ELAPSED2COMMUNICATE  0.1377937036219672  < MAX2DELTA:  1.33  ENOUGH TIME ALLOCATED
        # COUNT2COMMUNICATE  153  >= MAX2COMMUNICATE:  132  ITERATIONS USED
        # RESULT  <data4xi>STOP</data4xi>  LAST RECEIVED MESSAGE
        # SEND CHANNEL  1 : <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C34E0>
        # RECEIVE CHANNEL  1 : <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C3CC0>
        # 33 OBJECTS PASSED THROUGH CONNECTION IN  0.1377937036219672  SECONDS
        # AVERAGE NUMBER/SEC: 239.48844637004962
        # ==================================================

        # ==================================================
        # ITERATIONS:  40
        # CHANNEL  1
        # COUNT2SENT:  2
        # COUNT2RECEIVED:  42
        # COUNT2FAILED:  0
        # ELAPSED2COMMUNICATE;  0.17351245764401035
        # COUNT2COMMUNICATE:  181
        # COUNT2RECEIVED  42  = ITERATIONS + 2  42  <=> ALL DATA RECEIVED
        # ELAPSED2COMMUNICATE  0.17351245764401035  < DELTA:  1  ENOUGH TIME ALLOCATED
        # COUNT2COMMUNICATE  181  >= MAX2COMMUNICATE:  160  ITERATIONS USED
        # RESULT  <data4xi>STOP</data4xi>  LAST RECEIVED MESSAGE
        # ==================================================
                       
        # ==================================================
        # ITERATIONS:  80
        # CHANNEL  1
        # COUNT2SENT:  2
        # COUNT2RECEIVED:  82
        # COUNT2FAILED:  0
        # ELAPSED2COMMUNICATE;  0.3342443691449073
        # COUNT2COMMUNICATE:  341
        # COUNT2RECEIVED  82  = ITERATIONS + 2  82  <=> ALL DATA RECEIVED
        # ELAPSED2COMMUNICATE  0.3342443691449073  < MAX2DELTA:  1.8  ENOUGH TIME ALLOCATED
        # COUNT2COMMUNICATE  341  >= MAX2COMMUNICATE:  320  ITERATIONS USED
        # RESULT  <data4xi>STOP</data4xi>  LAST RECEIVED MESSAGE
        # SEND CHANNEL  1 : <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C6470>
        # RECEIVE CHANNEL  1 : <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C64A8>
        # 80 OBJECTS PASSED THROUGH CONNECTION IN  0.3342443691449073  SECONDS
        # AVERAGE NUMBER/SEC: 239.34584209948812
        # ==================================================

        # ==================================================
        # ITERATIONS:  800
        # CHANNEL  1
        # COUNT2SENT:  2
        # COUNT2RECEIVED:  802
        # COUNT2FAILED:  0
        # ELAPSED2COMMUNICATE;  3.251764799681084
        # COUNT2COMMUNICATE:  3221
        # COUNT2RECEIVED  802  = ITERATIONS + 2  802  <=> ALL DATA RECEIVED
        # ELAPSED2COMMUNICATE  3.251764799681084  < MAX2DELTA:  9.0  ENOUGH TIME ALLOCATED
        # COUNT2COMMUNICATE  3221  >= MAX2COMMUNICATE:  3200  ITERATIONS USED
        # RESULT  <data4xi>STOP</data4xi>  LAST RECEIVED MESSAGE
        # SEND CHANNEL  1 : <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003A7C470>
        # RECEIVE CHANNEL  1 : <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003A7C4A8>
        # 800 OBJECTS PASSED THROUGH CONNECTION IN  3.251764799681084  SECONDS
        # AVERAGE NUMBER/SEC: 246.0202533954669
        # ==================================================
        
        # ==================================================
        # ITERATIONS:  8000
        # CHANNEL  1
        # COUNT2SENT:  2
        # COUNT2RECEIVED:  8002
        # COUNT2FAILED:  0
        # ELAPSED2COMMUNICATE;  32.50084145903927
        # COUNT2COMMUNICATE:  32021
        # COUNT2RECEIVED  8002  = ITERATIONS + 2  8002  <=> ALL DATA RECEIVED
        # ELAPSED2COMMUNICATE  32.50084145903927  < MAX2DELTA:  81.0  ENOUGH TIME ALLOCATED
        # COUNT2COMMUNICATE  32021  >= MAX2COMMUNICATE:  32000  ITERATIONS USED
        # RESULT  <data4xi>STOP</data4xi>  LAST RECEIVED MESSAGE
        # SEND CHANNEL  1 : <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003AA7470>
        # RECEIVE CHANNEL  1 : <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003AA74A8>
        # 8000 OBJECTS PASSED THROUGH CONNECTION IN  32.50084145903927  SECONDS
        # AVERAGE NUMBER/SEC: 246.14747313796104
        # ==================================================
                                                                                       
    # ---------------------------------------------------------------------------------------------
    # CHANNELS
    # ---------------------------------------------------------------------------------------------                            
    try:                            
        keys2a = kb2deliver.keys()
        for key2a in keys2a:
            print ('SEND CHANNEL ', key2a, ':' , kb2deliver[key2a])
        keys2b = kb2receive.keys()
        for key2b in keys2b:
            print ('RECEIVE CHANNEL ', key2b, ':' , kb2receive[key2b])    
        
            # SEND CHANNEL     1 : <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003B46EB8>
            # SEND CHANNEL     2 : <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003B46D68>
            # SEND CHANNEL     3 : <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003B46828>
            
            # RECEIVE CHANNEL  1 : <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003B46A58>
            # RECEIVE CHANNEL  2 : <pipeconnection4xi.PipeConnection4Xi object at 0x00000000051C6048>
            # RECEIVE CHANNEL  3 : <pipeconnection4xi.PipeConnection4Xi object at 0x00000000051C61D0>    
    except:
        print ('(STEP 7Z/33) OF TEST_PIPESPEED4XI *** FAILED TO PRINT CHANNELS ', time4xi())                                
                                         
    # ---------------------------------------------------------------------------------------------
    # BENCHMARK
    # ---------------------------------------------------------------------------------------------
    try:        
        print (iterations, 'OBJECTS PASSED THROUGH CONNECTION IN ', elapsed2communicate,' SECONDS')
        #
        if elapsed2communicate > 0: 
            print ('AVERAGE NUMBER/SEC:', iterations/elapsed2communicate)
            # 

    except:
        print ('(STEP 6Z/33) OF TEST_PIPESPEED4XI *** FAILED TO PRINT PIPE STATISTICS ', time4xi())
        #
        
    print ('==================================================')        
         
    # ---------------------------------------------------------------------------------------------
    # RETURN
    # ---------------------------------------------------------------------------------------------        
    print ('(STEP 33/33) OF TEST_PIPESPEED4XI - RETURNING ', time4xi())
    #     
#</function4xi>

#[*]     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_seqspeed" usage = "
#   testing sequence speed
#"> 
# -------------------------------------------------------------------------------------------------
def test_seqspeed(seq):
    elapsed = 0
    iterations = 1

    while elapsed < delta:
        iterations *= 2

        t = _timer()

        for i in range(iterations):
            a = seq[5]

        elapsed = _timer()-t

    print (iterations, 'iterations in', elapsed, 'seconds')
    print ('average number/sec:', iterations/elapsed)
#</function4xi>

#[0] 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_lockspeed" usage = "
#   testing lock speed
#"> 
# -------------------------------------------------------------------------------------------------
def test_lockspeed(l):
    elapsed = 0
    iterations = 1

    while elapsed < delta:
        iterations *= 2

        t = _timer()

        for i in range(iterations):
            l.acquire()
            l.release()

        elapsed = _timer()-t

    print (iterations, 'iterations in', elapsed, 'seconds')
    print ('average number/sec:', iterations/elapsed)
#</function4xi>

#[*] 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "conditionspeed_func" usage = "
#   testing condition speed
#"> 
# -------------------------------------------------------------------------------------------------
def conditionspeed_func(c, N):
    c.acquire()
    c.notify()

    for i in range(N):
        c.wait()
        c.notify()

    c.release()
#</function4xi>

#[*]     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_conditionspeed" usage = "
#   testing condition speed with Process
#"> 
# -------------------------------------------------------------------------------------------------
def test_conditionspeed(Process, c):
    elapsed = 0
    iterations = 1

    while elapsed < delta:
        iterations *= 2

        c.acquire()
        p = Process(target=conditionspeed_func, args=(c, iterations))
        p.start()

        c.wait()

        t = _timer()

        for i in range(iterations):
            c.notify()
            c.wait()

        elapsed = _timer()-t

        c.release()
        p.join()

    print (iterations * 2, 'waits in', elapsed, 'seconds')
    print ('average number/sec:', iterations * 2 / elapsed)
#</function4xi>

#[1] 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test1" usage = "
#   benchmart test with threading and standard multiprocessing  
#"> 
# -------------------------------------------------------------------------------------------------
def test1():
    manager = multiprocessing.Manager()

    gc.disable()

#   print ('\n\t######## testing Queue.Queue\n')
#   test_queuespeed(threading.Thread, Queue.Queue(),threading.Condition()) <--- failed
#   test_queuespeed(threading.Thread, Queue.Queue(),threading.Condition())

    print ('\n\t######## testing queue.Queue\n')  # <--- OK
    test_queuespeed(threading.Thread, queue.Queue(),threading.Condition())
    test_queuespeed(threading.Thread, queue.Queue(),threading.Condition())
    # 65536 objects passed through the queue in 1.8956651108797187 seconds
    # average number/sec: 34571.50718440284
    # 65536 objects passed through the queue in 1.9293995895528928 seconds
    # average number/sec: 33967.04361028029
    
    
    print ('\n\t######## testing multiprocessing.Queue\n')
    test_queuespeed(multiprocessing.Process, multiprocessing.Queue(),
                    multiprocessing.Condition())
    # 32768 objects passed through the queue in 1.1473285059820988 seconds
    # average number/sec: 28560.25961975991                
                    
    print ('\n\t######## testing Queue managed by server process\n')
    test_queuespeed(multiprocessing.Process, manager.Queue(),
                    manager.Condition())
    # 8192 objects passed through the queue in 1.6504119619658724 seconds
    # average number/sec: 4963.609201088301  
                  
    print ('\n\t######## testing multiprocessing.Pipe\n')
    test_pipespeed()
    # 65536 objects passed through connection in 1.885998714761584 seconds
    # average number/sec: 34748.69812320347
    
    print ('\n\t######## testing list\n')
    test_seqspeed(range(10))
    # 8388608 iterations in 1.48088263668415 seconds
    # average number/sec: 5664600.146020325    
    
    print ('\n\t######## testing list managed by server process\n')
    test_seqspeed(manager.list(range(10)))
    # 16384 iterations in 1.2904447467075713 seconds
    # average number/sec: 12696.397921570828
    
    
    print ('\n\t######## testing Array("i", ..., lock=False)\n')

#   test_seqspeed(multiprocessing.Array('i', range(10), lock=False))  <-- failed to assetion error !
#   print ('\n\t######## testing Array("i", ..., lock=True)\n')  <-- failed to assetion error !
#   test_seqspeed(multiprocessing.Array('i', range(10), lock=True))


    
    print ('\n\t######## testing threading.Lock\n')
    test_lockspeed(threading.Lock())
    # 4194304 iterations in 1.5294247840528357 seconds
    # average number/sec: 2742406.193317646    
    
    
    print ('\n\t######## testing threading.RLock\n')
    test_lockspeed(threading.RLock())
    # 4194304 iterations in 1.57286488572381 seconds
    # average number/sec: 2666665.1649927585    
    
    print ('\n\t######## testing multiprocessing.Lock\n')
    test_lockspeed(multiprocessing.Lock())
    # 2097152 iterations in 1.6106040142173512 seconds
    # average number/sec: 1302090.3844071687    
    
    print ('\n\t######## testing multiprocessing.RLock\n')
    test_lockspeed(multiprocessing.RLock())
    # 2097152 iterations in 1.6203517343542941 seconds
    # average number/sec: 1294257.2625046188    

    print ('\n\t######## testing lock managed by server process\n')
    test_lockspeed(manager.Lock())
    # 8192 iterations in 1.2709135876489555 seconds
    # average number/sec: 6445.7568788404105
    
    print ('\n\t######## testing rlock managed by server process\n')
    test_lockspeed(manager.RLock())
    # 8192 iterations in 1.276197097529824 seconds
    # average number/sec: 6419.071173141073
    
    print ('\n\t######## testing threading.Condition\n')
    test_conditionspeed(threading.Thread, threading.Condition())
    # 65536 waits in 1.04112571577096 seconds
    # average number/sec: 62947.24931606381    

    print ('\n\t######## testing multiprocessing.Condition\n')
    test_conditionspeed(multiprocessing.Process, multiprocessing.Condition())
    # 65536 waits in 1.3939415200575382 seconds
    # average number/sec: 47014.88481187851
        
    print ('\n\t######## testing condition managed by a server process\n')
    test_conditionspeed(multiprocessing.Process, manager.Condition())
    # 8192 waits in 1.5431101812887817 seconds
    # average number/sec: 5308.758959232689

    gc.enable()
#</function4xi>

#[2] 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test2" usage = "
#   benchmark test with threading and dragon2xi multiprocessing 
#"> 
# -------------------------------------------------------------------------------------------------
def test2():

    manager = Manager()
    manager2xi = Manager2Xi()

    gc.disable()

    print ('\n\t######## 1) testing queue speed with threading \n')  
    test_queuespeed(threading.Thread, queue.Queue(),threading.Condition())
    # 65536 objects passed through the queue in 1.9508624332465345 seconds
    # average number/sec: 33593.3476821008
    
    print ('\n\t######## 2) testing  queue speed with multiprocessing \n')
    test_queuespeed(multiprocessing.Process, manager.Queue(), manager.Condition())
    # 8192 objects passed through the queue in 1.667420800770504 seconds
    # average number/sec: 4912.9769739075655
    
    print ('\n\t######## 3) testing queue speed with dragon2xi multiprocessing \n')
    test_queuespeed(Process2Xi, Queue2Xi(), Condition2Xi())
    # 32768 objects passed through the queue in 1.1783311354587056 seconds
    # average number/sec: 27808.821318503087   
                  
                    
    print ('\n\t######## 2) testing multiprocessing.Pipe speed \n')
    test_pipespeed()
    # 65536 objects passed through connection in 1.8851755881241417 seconds
    # average number/sec: 34763.87049187927
    
    print ('\n\t######## 3) testing Pipe2Xi speed \n')
    test_pipespeed2xi()
    # 65536 objects passed through connection in 1.899148330226545 seconds
    # average number/sec: 34508.099739730365
    
    print ('\n\t######## 1) testing list\ speed n')
    test_seqspeed(range(10))
    
    print ('\n\t######## 2) testing manager.list speed \n')
    test_seqspeed(manager.list(range(10)))
    # 8388608 iterations in 1.4780547932536123 seconds
    # average number/sec: 5675437.770161636
    
    print ('\n\t######## 3) testing manager2xi.list speed \n')
    test_seqspeed(manager2xi.list(range(10)))
    # 16384 iterations in 1.3056788083958324 seconds
    # average number/sec: 12548.262171865617    
  
    print ('\n\t######## 1) testing Array("i", ..., lock=False)  speed  \n')

#   test_seqspeed(multiprocessing.Array('i', range(10), lock=False))  <-- failed in assetion error !
#   print ('\n\t######## testing Array("i", ..., lock=True)\n')  <-- failed in assetion error !
#   test_seqspeed(multiprocessing.Array('i', range(10), lock=True))


    print ('\n\t######## 1) testing threading.Lock speed \n')
    test_lockspeed(threading.Lock())
    # 4194304 iterations in 1.5435416769650487 seconds
    # average number/sec: 2717324.749045292    
    
    print ('\n\t######## 2) testing multiprocessing.Lock speed \n')
    test_lockspeed(multiprocessing.Lock())
    # 2097152 iterations in 1.5688930844286801 seconds
    # average number/sec: 1336708.040091647    
    
    
    print ('\n\t######## 3) testing Lock2Xi speed \n')
    test_lockspeed(Lock2Xi())
    # 2097152 iterations in 1.5834609269981357 seconds
    # average number/sec: 1324410.3243997945    
        
    print ('\n\t######## 1) testing threading.RLock speed \n')
    test_lockspeed(threading.RLock())
    # 4194304 iterations in 1.5960033231226518 seconds
    # average number/sec: 2628004.553144449    
    
    print ('\n\t######## 2) testing multiprocessing.RLock speed \n')
    test_lockspeed(multiprocessing.RLock())
    # 2097152 iterations in 1.591680393416901 seconds
    # average number/sec: 1317571.045464718    
    
    print ('\n\t######## 3) testing RLock2Xi speed \n')
    test_lockspeed(RLock2Xi())
    # 2097152 iterations in 1.5969999410002202 seconds
    # average number/sec: 1313182.26517061    
 
    print ('\n\t######## 2) testing lock managed by server process speed\n')
    test_lockspeed(manager.Lock())
    # 8192 iterations in 1.270827479864323 seconds
    # average number/sec: 6446.193625648227    
    
    print ('\n\t######## 3) testing RLock2Xi speed \n')
    test_lockspeed(RLock2Xi())
    # 2097152 iterations in 1.5864246293777455 seconds
    # average number/sec: 1321936.1078771078

    print ('\n\t######## 1) testing threading.Condition speed \n')
    test_conditionspeed(threading.Thread, threading.Condition())
    # 65536 waits in 1.0363409932054566 seconds
    # average number/sec: 63237.87289094272    
    
    print ('\n\t######## 2) testing multiprocessing.Condition speed \n')
    test_conditionspeed(multiprocessing.Process, multiprocessing.Condition())
    # 65536 waits in 1.3834759161310188 seconds
    # average number/sec: 47370.5391151844    
    
    print ('\n\t######## 3) Process2Xi, Condition2Xi speed \n')
    test_conditionspeed(Process2Xi, Condition2Xi())
    # 65536 waits in 1.4395161380339658 seconds
    # average number/sec: 45526.40867889573
    
    gc.enable()    
#</function4xi>

#[4]     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test4" usage = "
#   benchmark test with threading and dragon4xi multiprocessing
#"> 
# -------------------------------------------------------------------------------------------------
def test4():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 0/33) OF TEST4_BENCHMARK  - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   

    # -----------------------------------------------------------------------------------------    
    # (STEP 2/2)
    # -----------------------------------------------------------------------------------------      
    print('=' *33)
    print("(STEP 2/2a) STARTING TEST4 ", time4xi()) 
    print('=' *33)

    manager = Manager()
    manager2xi = Manager2Xi()   
    # manager4xi = Manager4Xi()  
        
    gc.disable()
    # -----------------------------------------------------------------------------------------    
    # QUEUES - OK
    # -----------------------------------------------------------------------------------------         
    queue2test = True
    if queue2test is True:
        print ('\n\t######## starting four(4) queue benchmarks ', time4xi())
        # 10:13:04 02/15/13 Pacific Standard Time
        
        # -------------------------------------------------------------------------------------
        # OK
        # -------------------------------------------------------------------------------------
        queue2test1 = False
        if queue2test1 is True:
            try:
                print ('\n\t######## 1) testing queue speed with threading \n')  
                test_queuespeed(threading.Thread, queue.Queue(),threading.Condition())
                # Process passed to test_queuespeed:  <class 'threading.Thread'>
                # q passed to test_queuespeed:   <queue.Queue object at 0x0000000003926828>
                # c passed to test_queuespeed:  <Condition(<_thread.RLock owner=0 count=0>, 0)>
                # 65536 objects passed through the queue in 1.9425272766934003 seconds
                # average number/sec: 33737.49279421002
            except:
                print ('\n\t######## *** failed testing queue speed with threading \n')
        else:
            print ('\n\t######## skipped testing queue speed with threading \n', time4xi())
            
        # -------------------------------------------------------------------------------------
        # OK
        # -------------------------------------------------------------------------------------                 
        queue2test2 = False
        if queue2test2 is True:            
            try:
                print ('\n\t######## 2) testing  Queue speed with multiprocessing \n')
                test_queuespeed(multiprocessing.Process, manager.Queue(), manager.Condition())
                # Process passed to test_queuespeed:  <class 'multiprocessing.process.Process'>
                # q passed to test_queuespeed:   <queue.Queue object at 0x0000000003A625F8>
                # c passed to test_queuespeed:  <Condition(<_thread.RLock owner=0 count=0>, 0)>
                # 8192 objects passed through the queue in 1.6448452056419658 seconds
                # average number/sec: 4980.407865676788
            except:
                print ('\n\t######## *** failed testing  Queue speed with multiprocessing \n')
        else:
            print ('\n\t######## skipped testing  Queue speed with multiprocessing \n', time4xi())
            
        # -------------------------------------------------------------------------------------
        # OK
        # -------------------------------------------------------------------------------------                
        queue2test3 = False
        if queue2test3 is True:            
            try:
                print ('\n\t######## 3) testing hyprid Queue2Xi speed with multiprocessing4xi \n')
                test_queuespeed(Process2Xi, Queue2Xi(), Condition2Xi())
                # Process passed to test_queuespeed:  <class 'process2xi.Process2Xi'>
                # q passed to test_queuespeed:   <queue2xi.Queue2Xi object at 0x0000000003926828>
                # c passed to test_queuespeed:  <Condition(<RLock(None, 0)>, 0)>
                # 32768 objects passed through the queue in 1.1703783975476796 seconds
                # average number/sec: 27997.782656155934
            except:
                print ('\n\t######## *** failed testing hyprid Queue2Xi speed with multiprocessing4xi \n')
        else:
            print ('\n\t######## skipped testing hyprid Queue2Xi speed with multiprocessing4xi \n', time4xi())
            
        # -------------------------------------------------------------------------------------
        # OK
        # -------------------------------------------------------------------------------------                
        queue2test4 = True
        if queue2test4 is True:            
            try: 
                print ('\n\t######## 4) testing dragon Queue4Xi speed with multiprocessing4xi \n')
                test_queuespeed4xi()
                # queuespeed_func4xi: passed q:  <queue4xi.Queue4Xi object at 0x0000000003926630>
                # queuespeed_func4xi: passed iterations:  2
                # 512 objects passed through the queue in  1.4674580405173572 seconds
                # average number/sec: 348.90265061309196 <-- trace on
            except:
                print ('\n\t######## *** failed testing dragon Queue4Xi speed with multiprocessing4xi \n')
        else:
            print ('\n\t######## skipped testing dragon Queue4Xi speed ', time4xi())                                      
    else:
        print ('\n\t######## 0) skipped testing queues ', time4xi())
           
    # -----------------------------------------------------------------------------------------    
    # PIPES - OK
    # -----------------------------------------------------------------------------------------        
    pipe2test = True
    if pipe2test is True:
        print ('\n\t######## starting three (3) pipe benchmarks ', time4xi())
         
        # -------------------------------------------------------------------------------------
        # OK
        # -------------------------------------------------------------------------------------
        pipe2test2 = False
        if pipe2test2 is True: 
            try:               
                print ('\n\t######## 2) testing multiprocessing.Pipe speed \n')
                test_pipespeed()
                # 65536 objects passed through connection in 1.9211613308143392 seconds
                # average number/sec: 34112.699932504205
            except:
                print ('\n\t######## *** failed testing multiprocessing.Pipe speed *** ', time4xi())
        else:
            print ('\n\t######## skipped testing multiprocessing.Pipe speed ', time4xi())
             
        # -------------------------------------------------------------------------------------
        # OK
        # -------------------------------------------------------------------------------------    
        pipe2test3 = False
        if pipe2test3 is True:    
            try:    
                print ('\n\t######## 3) testing hyprid Pipe2Xi speed \n')
                test_pipespeed2xi()
                # 65536 objects passed through connection in 1.9049799658379598 seconds
                # average number/sec: 34402.46153516482
            except:
                print ('\n\t######## *** failed testing hyprid Pipe2Xi speed *** ', time4xi())
        else:
            print ('\n\t######## skipped testing hyprid Pipe2Xi speed ', time4xi())
            
        # -------------------------------------------------------------------------------------
        # OK
        # -------------------------------------------------------------------------------------    
        pipe2test4 = True
        if pipe2test4 is True:                  
            try:    
                print ('\n\t######## 4) testing dragon Pipe4Xi speed with: ', test_pipespeed4xi) 
                test_pipespeed4xi()
                # average number/sec not applicable due to different kind of message control 
            except:
                print ('\n\t######## *** failed testing dragon Pipe4Xi speed *** ', time4xi())
        else:
             print ('\n\t######## skipped testing dragon Pipe4Xi speed *** ', time4xi())
        # -------------------------------------------------------------------------------------
        #
        # -------------------------------------------------------------------------------------                      
    else:
        print ('\n\t######## 0) skipped testing pipes ', time4xi())  
           
    # -----------------------------------------------------------------------------------------    
    # SEQSPEED
    # -----------------------------------------------------------------------------------------     
    ack2seqspeed = False
    if ack2seqspeed is True:                       
          print ('\n\t######## 1) testing list\ speed n')
          test_seqspeed(range(10))
    
          print ('\n\t######## 2) testing manager.list speed \n')
          test_seqspeed(manager.list(range(10)))
          
    
          print ('\n\t######## 3) testing manager2xi.list speed \n')
          test_seqspeed(manager2xi.list(range(10)))
     
          print ('\n\t######## 1) testing Array("i", ..., lock=False)  speed  \n')
          test_seqspeed(multiprocessing.Array('i', range(10), lock=False))  # <-- failed in assetion error !
    
          print ('\n\t######## testing Array("i", ..., lock=True)\n')       # <-- failed in assetion error !
          test_seqspeed(multiprocessing.Array('i', range(10), lock=True))
    
           
    # -----------------------------------------------------------------------------------------    
    # LOCKSPEED 
    # ----------------------------------------------------------------------------------------- 
    ack2lockspeed = False
    if ack2lockspeed is True:     
                       
          print ('\n\t######## 1) testing threading.Lock speed \n')
          test_lockspeed(threading.Lock())
          
          print ('\n\t######## 2) testing multiprocessing.Lock speed \n')
          test_lockspeed(multiprocessing.Lock())
                  
          print ('\n\t######## 3) testing Lock2Xi speed \n')
          test_lockspeed(Lock2Xi())
           
            
          print ('\n\t######## 1) testing threading.RLock speed \n')
          test_lockspeed(threading.RLock())
            
          print ('\n\t######## 2) testing multiprocessing.RLock speed \n')
          test_lockspeed(multiprocessing.RLock())
             
            
          print ('\n\t######## 3) testing RLock2Xi speed \n')
          test_lockspeed(RLock2Xi())
          
          print ('\n\t######## 2) testing lock managed by server process speed\n')
          test_lockspeed(manager.Lock())
           
          print ('\n\t######## 3) testing RLock2Xi speed \n')
          test_lockspeed(RLock2Xi())
           
    # -----------------------------------------------------------------------------------------    
    # CONDITIONSPEED
    # -----------------------------------------------------------------------------------------      
    ack2conditionspeed = False
    if ack2conditionspeed is True:       
        print ('\n\t######## 1) testing threading.Condition speed \n')
        test_conditionspeed(threading.Thread, threading.Condition())
        # 
        
        print ('\n\t######## 2) testing multiprocessing.Condition speed \n')
        test_conditionspeed(multiprocessing.Process, multiprocessing.Condition())
        #   
        
        print ('\n\t######## 3) Process2Xi, Condition2Xi speed \n')
        test_conditionspeed(Process2Xi, Condition2Xi())
        # 
        
    gc.enable()
        

    # ---------------------------------------------------------------------------------------------    
    # Print Trace only if necessary - be aware that trace might start before operations are over!
    # ---------------------------------------------------------------------------------------------     
    ack2trace = False
    if ack2trace is True:
        print_trace4xi(t2xi)          
                                    
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main of test_benchmark_mp_xi4
#">                               
# -------------------------------------------------------------------------------------------------           
def main(argv=None):
    
    multiprocessing.freeze_support()

   
    focus2original = False
    if focus2original is True:         
        print('=' *80)
        print ('PHASE1 OF TEST_BENCHMARK_MP_XI4.PY - STARTING BENCHMARKS WITH ORIGINAL MULTIPROCESSING ', time4xi())
        print('=' *80)
        # 06:52:46 02/12/13 Pacific Standard Time
        
        test1()
        
        print('=' *80)
        print ('PHASE1 OF TEST_BENCHMARK_MP_XI4.PY - COMPLETED BENCHMARKS WITH ORIGINAL MULTIPROCESSING ', time4xi())
        print('=' *80)
        # 06:54:02 02/12/13 Pacific Standard Time
        # ========
        #     1:16 = 76 sec
        
    focus2hybrid = False
    if focus2hybrid is True:         
        print('=' *80)
        print ('PHASE2 OF TEST_BENCHMARK_MP_XI4.PY - STARTING BENCHMARKS WITH HYBRID MULTIPROCESSING2XI ', time4xi())
        print('=' *80)
        # 07:02:03 02/12/13 Pacific Standard Time
        
        test2()
        
        print('=' *80)
        print ('PHASE2 OF TEST_BENCHMARK_MP_XI4.PY - COMPLETED BENCHMARKS WITH HYBRID MULTIPROCESSING2XI ', time4xi())
        print('=' *80)
        # 07:03:35 02/12/13 Pacific Standard Time
        # ========
        #     1:32 = 92 sec <-- do NOT compare these times because a phase may use other phase modules to compare itself !
        
    focus2dragon = True
    if focus2dragon is True:         
        print('=' *80)
        print ('PHASE4 OF TEST_BENCHMARK_MP_XI4.PY - STARTING BENCHMARKS WITH DRAGONIZED MULTIPROCESSING4XI ', time4xi())
        print('=' *80)
        
        test4()
        
        print('=' *80)
        print ('PHASE4 OF TEST_BENCHMARK_MP_XI4.PY - COMPLETED BENCHMARKS WITH DRAGONIZED MULTIPROCESSING4XI ', time4xi())
        print('=' *80)
    
#</function4xi>

# -------------------------------------------------------------------------------------------------
#                               
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    
   
    main()
          
    
        
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_benchmark_mp_xi4.txt
#   sense-test-benchmark4xi.xml
#   reason-test-benchmark4xi.xml
#   ace-test-benchmark4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_benchmark_mp_xi4.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

